mlpack_fastmks(1)

NAME
mlpack_fastmks - fastmks (fast max-kernel search)

SYNOPSIS
 mlpack_fastmks [-w double] [-b double] [-d double] [-m unknown] [-k int] [-K string] [-N bool] [-o double] [-q unknown] [-r unknown] [-s double] [-S bool] [-V bool] [-i unknown] [-p unknown] [-M unknown] [-h -v]

DESCRIPTION
This program will find the k maximum kernels of a set of points, using a query set and a reference set (which can optionally be the same set). More specifically, for each point in the query set, the k points in the reference set with maximum kernel evaluations are found. The kernel function used is specified with the '--kernel (-K)' parameter.

For example, the following command will calculate, for each point in the query set 'query.csv', the five points in the reference set 'reference.csv' with maximum kernel evaluation using the linear kernel. The kernel evaluations may be saved with the 'kernels.csv' output parameter and the indices may be saved with the 'indices.csv' output parameter.

$ mlpack_fastmks --k 5 --reference_file reference.csv --query_file query.csv --indices_file indices.csv --kernels_file kernels.csv --kernel linear

The output matrices are organized such that row i and column j in the indices matrix corresponds to the index of the point in the reference set that has j'th largest kernel evaluation with the point in the query set with index i. Row i and column j in the kernels matrix corresponds to the kernel evaluation between those two points.

This program performs FastMKS using a cover tree. The base used to build the cover tree can be specified with the '--base (-b)' parameter.

OPTIONAL INPUT OPTIONS

--bandwidth (-w) [double]
    Bandwidth (for Gaussian, Epanechnikov, and triangular kernels). Default value 1.

--base (-b) [double]
    Base to use during cover tree construction. Default value 2.

--degree (-d) [double]
    Degree of polynomial kernel. Default value 2.

--help (-h) [bool]
    Default help info.

--info [string]
    Print help on a specific option. Default value ''.

--input_model_file (-m) [unknown]
    Input FastMKS model to use.

--k (-k) [int]
    Number of maximum kernels to find. Default value 0.

--kernel (-K) [string]
    Kernel type to use: 'linear', 'polynomial', 'cosine', 'gaussian', 'epanechnikov', 'triangular', 'hyptan'. Default value 'linear'.

--naive (-N) [bool]
    If true, O(n^2) naive mode is used for computation.

--offset (-o) [double]
    Offset of kernel (for polynomial and hyptan kernels). Default value 0.

--query_file (-q) [unknown]
    The query dataset.

--reference_file (-r) [unknown]
    The reference dataset.

--scale (-s) [double]
    Scale of kernel (for hyptan kernel). Default value 1.

--single (-S) [bool]
    If true, single-tree search is used (as opposed to dual-tree search.

--verbose (-v) [bool]
    Display informational messages and the full list of parameters and timers at the end of execution.

--version (-V) [bool]
    Display the version of mlpack.

OPTIONAL OUTPUT OPTIONS

--indices_file (-i) [unknown]
    Output matrix of indices.

--kernels_file (-p) [unknown]
    Output matrix of kernels.

--output_model_file (-M) [unknown]
    Output for FastMKS model.nnADDITIONAL INFORMATIONNN FOR FURTHER INFORMATION, INCLUDING RELEVANT PAPERS, CITATIONS, AND THEORY, consult the documentation found at http://www.mlpack.org or included with your distribution of mlpack.